<template>

<!--
  /:id - динамический параметр можно найти в $route.params.id или передать как props
 -->
  <article id="post" class="container">
    <div class="row">
      <header class="col-12">
        <h1>{{ news.title }}</h1>
        <img :src="getImg(news)" :alt="news.title" style="width: 100%">
      </header>
      <section class="col-12">
        <p>{{ news.desc }}</p>
      </section>
    </div>

  </article>

  <!--
глобальные хуки: (Реггистрируется в файле с созданным экземпляром роутинга)
    router.beforeEach
    router.afterEach

хук для конкретного роута: (Реггистрируется в самом обьекте роута)
    beforeEnter

хуки для конкретного компонента (Реггистрируется в самих компонентах)
    beforeRouteEnter - не имеет доступ к контексту компонента(this),
        но в next() можно передать колбек в который принять аргумент с контекстом
        (единствинный хук в котором в next можно передать колбек)

    beforeRouteUpdate - вызывается на переиспользуемых компонентах
    beforeRouteLeave - имеет доступ к контексту компонента(this)

Все хуки принимают в виде аргумента колбек, в колбек передают три аргументы:
  to - целевой объект Route, к которому осуществляется переход
  from - Route текущий маршрут, с которого осуществляется переход к новому.
  next - функция, вызов которой разрешает хук
  результат выполнения next зависит от переданных аргументов:

    next() - переход к следующему хуку в цепочке. Если хуков больше нет, переход считается подтверждённым.
    next(false) - отмена перехода.
    next('/') или next({ path: '/' }) - перенаправление на другой маршрут. Текущий переход будет отменён, и хуки буду перезапущены по новому для нового роута.
    next(error) - если аргумент, переданный next является экземпляром Error, навигация будет прервана и ошибка будет передана в коллбэк, зарегистрированный через router.onError().

    next в хуке может вызываться только один раз, иначе будет ошибка

  router.afterEach - только в этот глобальный хук не передается next, и на навигацию он не влеяет
  -->
  
</template>

<script>
  import defImg from '@/assets/js/mixin_defaultImg'

  export default {
    name: "SingleNews",
    mixins: [ defImg ],
    props: {
      // в id попадет значение параметра с роута ($route.params.id === id)
      id: [Number, String],
      newPar: [Object, Array]
    },
    data() {
      return {
        news: {}
      }
    },
    watch: {
      '$route': 'getSingleNews'
    },

    //навигационные хуки
    beforeRouteEnter(to, from, next) {
      console.log('beforeRouteEnter')
      next(vm => {vm.getSingleNews()})
    },
    beforeRouteUpdate(to, from, next) {
      console.log('beforeRouteUpdate')
      next()
    },
    beforeRouteLeave(to, from, next) {
      console.log('beforeRouteLeave')
      alert('stop')
      next()
    },

    methods: {
      getSingleNews() {
        const vm = this
        this.news = vm.newPar
        console.log(vm.$route.params.newPar) //vm.$route.params.newPar === vm.newPar
      }
    }

  }

</script>

<style lang="sass">

</style>